#!/bin/sh
# $Id: t-pm-rsad-2.sh,v 1.2 2007/02/17 01:17:27 ca Exp $
#
# ----------------------------------------
# test pmilter RSAD
# uses smtpcnf.sh.
# ----------------------------------------
#
test -s stop && exit 1
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

SCRIPTS=`cd ${SD} && pwd`

if ../smtps/smtps -VVV | ${GREP} MTA_USE_PMILTER >/dev/null
then
  :
else
  echo "SKIPPED: $0: smtps not compiled with MTA_USE_PMILTER (--enable-pmilter)"
  exit 0
fi

if ../smtps/smtps -VVV | ${GREP} MTA_USE_RSAD >/dev/null
then
  :
else
  echo "SKIPPED: $0: smtps not compiled with MTA_USE_RSAD"
  exit 0
fi

PMPRG="-p ../libpmilter/t-pmilter-1"
PMOPT=""

if test X"`uname`" != "XOSF1"
then
while getopts O:p:s:V FLAG
do
  case "${FLAG}" in
    O) PMOPT="${PMOPT} ${OPTARG}";;
    p) PMPRG="-p ${OPTARG}";;
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to right directory (where the programs will be executed).
cd ../qmgr || exit 1
rm -f ${MTMAP}

${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4; }
smar { Log_Level = 12; nameserver = ${NS}; }
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }

smtps {
Log_Level = 19;
flags={prdr};
daemon_address = localhost:${SRVPORT};
wait_for_server=4;
policy_milter { socket {type=unix; path="pmilter.sock";} timeout=2; }
}

EOF

# ----------------------------------------
# reject rcpt command in milter (deferred): 2*perm
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
# XREF: SMTP_R_D_EOM=353
if ${SHELL} ${SCRIPTS}/smtpcnf.sh ${PMPRG} ${PMOPT} -P "-r b=353" -Z 'smtpc2' -c '-E -9' -E 0 -A 0 -X 0 $@ -S"a@b.c" -n 2 -R"d550@y.z -Rd552@y.z"
then
    ERR=false
else
    echo "$0: test ${TEST} failed"
    ERR=true
    test X"${MTA_STOPONERROR}" != X && exit 1
fi

if ${GREP} 'RCPT=error, text=550 5.7.0 Rejected' ${CLTL} >/dev/null
then
  if ${GREP} 'RCPT=error, text=550 5.1.1 Recipient rejected' ${CLTL} >/dev/null
  then
    if ${GREP} 'DOT=error, text=550 5.7.0 Rejected' ${CLTL} >/dev/null
    then
      :
    else
      echo "$0: ${TEST}: missing DOT=error, text=550 5.7.0 Rejected"
      ERR=true
    fi
  else
    echo "$0: ${TEST}: missing RCPT=error, text=550 5.1.1 Recipient rejected"
    ERR=true
  fi
else
  echo "$0: ${TEST}: missing RCPT=error, text=550 5.7.0 Rejected"
  ERR=true
fi

if ${ERR}
then
    echo "$0: test ${TEST} check failed"
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
else
    ${VERBOSE} && echo "test ${TEST} succeeded"
fi
fi


# ----------------------------------------
# end
if test "${ERRS}" = "0"
then
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
