/*
 * Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: version.h,v 1.22 2007/08/06 13:50:33 ca Exp $
 */

#ifndef SM_VERSION_H
#define SM_VERSION_H 1

#include "sm/generic.h"

#if MTA_VERSION_OVERRIDE

#ifdef MTA_MAJOR
#undef MTA_MAJOR
#endif
#ifdef MTA_MINOR
#undef MTA_MINOR
#endif
#ifdef MTA_TYPE_N
#undef MTA_TYPE_N
#endif
#ifdef MTA_TYPE
#undef MTA_TYPE
#endif
#ifdef MTA_TYPEVERSION
#undef MTA_TYPEVERSION
#endif
#ifdef MTA_LEVEL
#undef MTA_LEVEL
#endif

/* see configure.ac for relationship between MTA_TYPE and MTA_TYPE_N */
#define MTA_MAJOR	1
#define MTA_MINOR	0
#define MTA_TYPE_N	0
#if MTA_TYPE_N == 0
#define MTA_TYPE	PreAlpha
#elif MTA_TYPE_N == 1
#define MTA_TYPE	Alpha
#elif MTA_TYPE_N == 2
#define MTA_TYPE	Beta
#elif MTA_TYPE_N == 3
#define MTA_TYPE	Gamma
#else
#define MTA_TYPE	
#endif
#define MTA_TYPEVERSION	0
#define MTA_LEVEL	0

#else /* MTA_VERSION_OVERRIDE */

/* 8 bit */
#ifndef MTA_MAJOR
#define MTA_MAJOR	0
#endif

/* 5 bit */
#ifndef MTA_MINOR
#define MTA_MINOR	0
#endif

#ifndef MTA_TYPE
#define MTA_TYPE	Alpha
#endif

/* 3 bit */
#ifndef MTA_TYPE_N
#define MTA_TYPE_N	0
#endif

/* 8 bit */
#ifndef MTA_TYPEVERSION
#define MTA_TYPEVERSION	1
#endif

/* 8 bit */
#ifndef MTA_LEVEL
#define MTA_LEVEL	0
#endif

#endif /* MTA_VERSION_OVERRIDE */

#define MTA_VERSION_STR	"MeTA1-" SM_XSTR(MTA_MAJOR) "." SM_XSTR(MTA_MINOR) "." SM_XSTR(MTA_TYPE) SM_XSTR(MTA_TYPEVERSION) "." SM_XSTR(MTA_LEVEL)

#define MTA_VERSION	(((MTA_MAJOR) << 24) + ((MTA_MINOR) << 19) + ((MTA_TYPE_N) << 16) + ((MTA_TYPEVERSION) << 8) + (MTA_LEVEL))

#endif /* SM_VERSION_H */
